<template>
	<q-card>
		<q-bar class="bg-primary text-white">
			<q-space />
			<div class="text-h6 q-mb-xs">Validation Campaign Settings</div>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip content-class="bg-white text-primary">Close</q-tooltip>
          </q-btn>
        </q-bar>
		<q-card-section>
			<p>{{selected.length}} entries selected for validation</p>
			<p>You can start the validation campaign or change the targeted entries.</p>
		</q-card-section>
		<q-card-section>
			<q-table
				ref="ofrlexValidationSettingsTable"
				class="my-sticky-header-table rounded-borders"
				title="Validation Target Entries"
				:data="items"
				:columns="fields"
				row-key="id"
				:loading="loading"
				loading-label="loading"
				binary-state-sort
				:visible-columns="visibleColumns"
				selection="multiple"
				:selected.sync="selected"
				dense
				>

				<template v-slot:top="props">
					<div class="row">
						<q-btn  flat color="default" :text-color="selected.length!=0?'red':''" icon="delete_forever" @click="remove()" :disable="selected.length==0">
							<q-tooltip :delay="300" content-class="bg-white text-primary">Remove from selection</q-tooltip>
						</q-btn>
						<q-space/>
						<q-select
						v-model="visibleColumns"
						multiple
						borderless
						dense
						options-dense
						:display-value="$q.lang.table.columns"
						emit-value
						map-options
						:options="filterFields()"
						option-value="name"
						style="min-width: 100px"
						data-v-step="columns"
						>
						<q-tooltip :delay="300" content-class="bg-white text-primary">Select visible columns</q-tooltip>
						</q-select>
					</div>
				</template>

			</q-table>
		</q-card-section>
		<q-card-actions align="around">
			<q-btn color="primary" @click="startValidationCampaign()" :disable="selected.length < 1">Start Campaign <q-tooltip :delay="300" content-class="bg-white text-primary">Start the validation campaign for all users</q-tooltip></q-btn>
		</q-card-actions>
	</q-card>
</template>

<script>
export default {
	name: 'validation-campaign-settings',
	props: ['selectedrows'],
	data(){
		return {
			items: this.selectedrows,
			fields: [
				{ name: 'id', label: 'ID', sortable: true, field: 'id' },
				{ name: 'ofrlexHeadword', label: 'Headword', sortable: true, field: 'ofrlexHeadword'},
				{ name: 'tllemma', label: 'Lemma', sortable: true, field: 'tllemma' },
				{ name: 'macroCat', label: 'Macro Cat', field: 'cat'},
				{ name: 'cat', label: 'Cat', sortable: true, field: 'cat'},
				{ name: 'manualCat', label: 'Cat', sortable: true, field: 'manualCat', align: 'center' },
				{ name: 'subCat', label: 'Subcat', sortable: true, field: 'subCat'},
				{ name: 'manualSubCat', label: 'SubCat', sortable: true, field: 'manualSubCat' },
				{ name: 'inflclass', label: 'Flexion', sortable: true, field: 'inflclass' },
				{ name: 'manualInflclass', label: 'Flexion', sortable: true, field: 'manualInflclass' },
				{ name: 'syntInfo', label: 'Syntactic Info', sortable: true, field: 'syntInfo'},
				{ name: 'manualSyntfeats', label: 'Syntactic Info', sortable: true, field: 'manualSyntfeats'},
				{ name: 'redistributions', label: 'Redistributions', sortable: true, field: 'redistributions'},
				{ name: 'manualRedistributions', label: 'Redistributions', sortable: true, field: 'manualRedistributions'},
				{ name: 'tlvariantOf', label: 'TLVariantOf', field: 'tlvariantOf'},
				{ name: 'variantOf', label: 'VariantOf', field: 'variantOf'},
				{ name: 'manualVariantOf', label: 'VariantOf', field: 'manualVariantOf'},
				{ name: 'pseudosyns', label: 'PseudoSyns', field: 'pseudosyns'},
				{ name: 'pseudoGlosses', label: 'Pseudo Glosses', sortable: true, field: 'pseudoGlosses'},
				{ name: 'glossFr', label: 'Gloss FR', sortable: true, field: 'glossFr'},
				{ name: 'descendent', label: 'Descendent', sortable: true, field: 'descendent'},
				{ name: 'glossHierarchy', label: 'Pseudo Glosses > French Gloss > Descendent', field: 'glossHierarchy', align: 'center'}
			],
			visibleColumns: ['ofrlexHeadword','macroCat','manualCat','manualSubCat','manualInflclass','manualSyntfeats','manualRedistributions', 'glossHierarchy', 'manualVariantOf', 'tllemma', 'pseudosyns'],
			selected: [],
			loading: false
		}
	},
	methods: {
		filterFields() {
			var tempArray = this.fields.filter(function( obj ) {
			return obj.field !== 'syntInfo' && obj.field !== 'cat' && obj.field !== 'redistributions' && obj.field !== 'subCat' && obj.field !== 'variantOf' && obj.field !== 'tlvariantOf' && obj.field !== 'inflclass' ;
			});
			return tempArray;
		},
		remove() {
			// should remove selected from items
		},
		startValidationCampaign(){
			if(this.items.length > 0){ 
				this.$store.getters.getStompClient.send("/app/ofrlex.startcampaign", JSON.stringify(this.items), {});
			 }
		},
	}
}
</script>